SystemOrganization addCategory: #'CodA-Kernel'!
SystemOrganization addCategory: #'CodA-Anonym Classes'!
SystemOrganization addCategory: #'CodA-Tests'!

Object subclass: #CodAMeta
	instanceVariableNames: 'metaComponents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodA-Kernel'!

!CodAMeta methodsFor: 'accessing' stamp: 'mab 11/8/2007 17:13'!
accept
	^ self componentAt: #Accept! !

!CodAMeta methodsFor: 'as yet unclassified' stamp: 'mab 11/8/2007 16:12'!
asExtendableMetaFor: anObject
	^self! !

!CodAMeta methodsFor: 'as yet unclassified' stamp: 'mab 11/8/2007 17:12'!
componentAt: aSelector
	^ metaComponents at: aSelector! !

!CodAMeta methodsFor: 'as yet unclassified' stamp: 'mab 11/8/2007 17:12'!
componentAt: aSelector put: aComponent
	^ metaComponents at: aSelector put: aComponent! !

!CodAMeta methodsFor: 'accessing' stamp: 'mab 11/8/2007 17:14'!
configuration
	^ self componentAt: #Configuration! !

!CodAMeta methodsFor: 'accessing' stamp: 'mab 11/8/2007 17:13'!
execution
	^ self componentAt: #Execution! !

!CodAMeta methodsFor: 'as yet unclassified' stamp: 'mab 11/8/2007 17:22'!
initialize
	metaComponents := Dictionary new.! !

!CodAMeta methodsFor: 'as yet unclassified' stamp: 'mab 11/8/2007 16:16'!
isExtendableMeta
	^true! !

!CodAMeta methodsFor: 'accessing' stamp: 'mab 11/8/2007 17:13'!
protocol
	^ self componentAt: #Protocol! !

!CodAMeta methodsFor: 'accessing' stamp: 'mab 11/8/2007 17:13'!
queue
	^ self componentAt: #Queue! !

!CodAMeta methodsFor: 'accessing' stamp: 'mab 11/8/2007 17:13'!
receive
	^ self componentAt: #Receive! !

!CodAMeta methodsFor: 'accessing' stamp: 'mab 11/8/2007 17:13'!
send
	^ self componentAt: #Send! !

!CodAMeta methodsFor: 'accessing' stamp: 'mab 11/8/2007 17:12'!
state
	^ self componentAt: #State! !

Object subclass: #CodAMetaComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodA-Kernel'!

Object subclass: #M
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodA-Kernel'!

!M class methodsFor: 'as yet unclassified' stamp: 'mab 12/5/2007 14:38'!
b
	^ CodAMessageBuilder new! !

!Object methodsFor: '*CodA' stamp: 'mab 12/5/2007 14:59'!
!!!! aMessage
	^ self meta send sendAsync: aMessage for: self! !

!Object methodsFor: '*CodA' stamp: 'mab 12/5/2007 14:57'!
<!! aMessage
	^ self meta send sendFuture: aMessage for: self! !

!Object methodsFor: '*CodA' stamp: 'mab 12/5/2007 15:00'!
<* aMessage
	^ self meta send send: aMessage for: self! !

!Object methodsFor: '*CodA' stamp: 'mab 12/5/2007 14:49'!
<> aMessage
	^ self meta send sendSync: aMessage for: self! !

!Object methodsFor: '*CodA' stamp: 'mab 11/8/2007 16:03'!
meta
	^self class! !

Object subclass: #ObjectMeta
	instanceVariableNames: 'meta baseClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodA-Anonym Classes'!

!ObjectMeta methodsFor: 'as yet unclassified' stamp: 'mab 11/8/2007 17:22'!
baseClass
	^ baseClass! !

!ObjectMeta methodsFor: 'as yet unclassified' stamp: 'mab 11/8/2007 17:22'!
baseClass: anObject
	baseClass := anObject! !

!ObjectMeta methodsFor: 'as yet unclassified' stamp: 'mab 11/8/2007 17:22'!
class
	^ self baseClass! !

!ObjectMeta methodsFor: 'as yet unclassified' stamp: 'mab 11/8/2007 17:22'!
meta
	^ meta! !

!ObjectMeta methodsFor: 'as yet unclassified' stamp: 'mab 11/8/2007 17:22'!
meta: anObject
	meta := anObject! !

ProtoObject subclass: #CodAMessageAccumulator
	instanceVariableNames: 'messageChain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodA-Kernel'!

!CodAMessageAccumulator class methodsFor: 'as yet unclassified' stamp: 'mab 12/5/2007 15:06'!
with: aMessageChain
	^self new instVarAt: #messageChain put: aMessageChain! !

!CodAMessageAccumulator methodsFor: 'as yet unclassified' stamp: 'mab 12/5/2007 15:05'!
doesNotUnderstand: message
	^ CodAMessageAccumulator with: (messageChain ifNil: [OrderedCollection new]), message! !

!CodAMessageAccumulator methodsFor: 'as yet unclassified' stamp: 'mab 12/5/2007 15:08'!
m
	^ messageChain! !

ProtoObject subclass: #CodAMessageBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodA-Kernel'!

!CodAMessageBuilder methodsFor: 'as yet unclassified' stamp: 'mab 12/5/2007 14:33'!
doesNotUnderstand: message
	^ message
	! !

!Class methodsFor: '*CodA' stamp: 'je 12/5/2007 16:04'!
asExtendableMetaFor: anObject 
	| anonymClass instVars |
	instVars := Set new.
	instVars add: 'meta';
		 add: 'baseClass'.
	anonymClass := ClassBuilder new
				newAnonymSubclassOf: anObject class
				type: anObject class typeOfClass
				instanceVariables: instVars
				from: nil.
	anonymClass compileSilently: 'baseClass
	^ baseClass' classified: 'blub'.
	anonymClass compileSilently: 'baseClass: anObject
	baseClass := anObject' classified: 'blub'.
	anonymClass compileSilently: 'meta
	^ meta' classified: 'blub'.
	anonymClass compileSilently: 'meta: anObject
	meta := anObject' classified: 'blub'.
	anonymClass compileSilently: 'class
	^ self baseClass' classified: 'blub'.
	anObject
		become: (anObject as: anonymClass).
	anObject perform: #meta: with: CodAMeta new.
	anObject perform: #baseClass: with: self! !

!Class methodsFor: '*CodA' stamp: 'mab 11/8/2007 16:14'!
isExtendableMeta
	^false! !

!ClassBuilder methodsFor: '*CodA' stamp: 'je 12/5/2007 16:03'!
newAnonymSubclassOf: newSuper type: type instanceVariables: instVars from: oldClass
	"Create a new subclass of the given superclass with the given specification."
	"WARNING: This method does not preserve the superclass/subclass invariant!!"
	| newFormat newClass |
	"Compute the format of the new class"
	newFormat := 
		self computeFormat: type 
			instSize: instVars size 
			forSuper: newSuper 
			ccIndex: (oldClass ifNil:[0] ifNotNil:[oldClass indexIfCompact]).

	newFormat == nil ifTrue:[^nil].

	(oldClass == nil or:[oldClass isMeta not]) 
		ifTrue:[newClass := self privateNewSubclassOf: newSuper from: oldClass]
		ifFalse:[newClass := oldClass clone].

	newClass 
		superclass: newSuper
		methodDictionary: MethodDictionary new
		format: newFormat;
		setInstVarNames: instVars.

	oldClass ifNotNil:[
		newClass organization: oldClass organization.
		"Recompile the new class"
		oldClass hasMethods 
			ifTrue:[newClass compileAllFrom: oldClass].

		oldClass hasTraitComposition ifTrue: [
			newClass setTraitComposition: oldClass traitComposition copyTraitExpression ].
		oldClass class hasTraitComposition ifTrue: [
			newClass class setTraitComposition: oldClass class traitComposition copyTraitExpression ].
		
		self recordClass: oldClass replacedBy: newClass.
	].

	^newClass! !

TestCase subclass: #CodaTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodA-Tests'!

!CodaTests methodsFor: 'as yet unclassified' stamp: 'mab 11/20/2007 11:14'!
testClassStaysTheSameAfterCreatingExtendableMeta
	| instance |
	instance := Object new.
	instance meta asExtendableMetaFor: instance.
	self assert: instance class == Object.! !

!CodaTests methodsFor: 'as yet unclassified' stamp: 'mab 11/20/2007 11:10'!
testInstanceStaysTheSameAfterCreatingExtendableMeta
	| instance oldInstance |
	instance := oldInstance := Object new.
	instance meta asExtendableMetaFor: instance.
	self assert: instance == oldInstance.! !

!CodaTests methodsFor: 'as yet unclassified' stamp: 'mab 12/5/2007 14:41'!
testMessageBuilderBuildsCorrectMessage
	| message |
	message := M b at: 1 put: 68.
	self assert: message arguments = #(1 68).
	self assert: message selector = #at:put:.! !

!CodaTests methodsFor: 'as yet unclassified' stamp: 'mab 11/20/2007 11:19'!
testMetaOfNormalInstanceIsClass
	| instance |
	instance := Object new.
	self assert: instance meta == instance class.! !

!CodaTests methodsFor: 'as yet unclassified' stamp: 'je 12/5/2007 16:19'!
testSubclassesAmountStaysTheSameAfterCreatingExtendableMeta
	| instance countBefore |
	countBefore := Object subclasses size.
	instance := Object new.
	instance meta asExtendableMetaFor: instance.
	self assert: countBefore == Object subclasses size.! !
